/* Dekker's Mutual Exclusion Protocol */

DekkerMEP{

    var int looser = 0;
    var bool will1 = false;
    var bool will2 = false; 

    process P1 {

        stateset idle, will_to_enter, you_first, cs;

        to idle: {}
        
        from idle to will_to_enter:
                     {	 looser = 1; }
        from will_to_enter to you_first:
                     {   will1 = true; }
        from you_first to cs:
                 when ( !will2 || looser != 1 )
                     {}
        from cs to idle:
                     { will1 = false; }
                
        prop { crit: in cs; } 
  
    }

    process P2 {

        stateset idle, will_to_enter, you_first, cs;

        to idle: {}

        from idle to will_to_enter:
                     {	 looser = 2; }
        from will_to_enter to you_first:
                     {   will2 = true; }
        from you_first to cs:
                 when ( !will1 || looser != 2 )
                     {}
        from cs to idle:
                     { will2 = false; }

        prop { crit: in cs; } 
  
    }

    main
         { P1 || P2 } 
          
    prop 
         { P1.crit; P2.crit; } 

}

/* properties:
     mutual exclusion :      AG( not P1.crit or not P2.crit ) 
     liveness:               AG( not P1.idle or AF P1.crit )
                             AG( not P2.idle or AF P2.crit )
*/

