public class College5 {

  public static void main(String args []) {
    Fork fork0 = new Fork(false);
    Fork fork1 = new Fork(false);
    Fork fork2 = new Fork(false);
    Fork fork3 = new Fork(false);
    Fork fork4 = new Fork(false);

    Philosopher p0 = new Philosopher(0, fork0, fork1);
    Philosopher p1 = new Philosopher(1, fork1, fork2);
    Philosopher p2 = new Philosopher(2, fork2, fork3);
    Philosopher p3 = new Philosopher(3, fork3, fork4);
    Philosopher p4 = new Philosopher(4, fork4, fork0);

    (new Thread(p0)).start();
    (new Thread(p1)).start();
    (new Thread(p2)).start();
    (new Thread(p3)).start();
    (new Thread(p4)).start();
  }
}

class Fork {

  private boolean unavailable;

  public Fork(boolean unavailable) {
    this.unavailable = unavailable;
  }

  public synchronized void acquire() {
    while (unavailable) {
      try {
        wait();
      } catch (InterruptedException e) {
      }
    }
    unavailable = true;
  }

  public synchronized void release() {
    unavailable = false;
    notify();
  }

}

class Philosopher implements Runnable {
  private int nr;
  private Fork left, right;

  public Philosopher(int nr, Fork left, Fork right) {
    this.nr = nr;
    this.left = left;
    this.right = right;
  }

  public void run() {
    while (true) {
      left.acquire();
      /* @(.inline infinite, .annotation @@NOTIFY_THREAD)observable */
      right.acquire();
      right.release();
      left.release();
    }
  }

}

