/* Author: Andrzej Zbrzezny (c) 2008 */

public class R10W10 {

  public static void main(String args []) {

    ReadingRoom readingRoom = new ReadingRoom();

    Reader r0 = new Reader(0, readingRoom);
    Reader r1 = new Reader(1, readingRoom);
    Reader r2 = new Reader(2, readingRoom);
    Reader r3 = new Reader(3, readingRoom);
    Reader r4 = new Reader(4, readingRoom);
    Reader r5 = new Reader(5, readingRoom);
    Reader r6 = new Reader(6, readingRoom);
    Reader r7 = new Reader(7, readingRoom);
    Reader r8 = new Reader(8, readingRoom);
    Reader r9 = new Reader(9, readingRoom);

    Writer w0 = new Writer(0, readingRoom);
    Writer w1 = new Writer(1, readingRoom);
    Writer w2 = new Writer(2, readingRoom);
    Writer w3 = new Writer(3, readingRoom);
    Writer w4 = new Writer(4, readingRoom);
    Writer w5 = new Writer(5, readingRoom);
    Writer w6 = new Writer(6, readingRoom);
    Writer w7 = new Writer(7, readingRoom);
    Writer w8 = new Writer(8, readingRoom);
    Writer w9 = new Writer(9, readingRoom);

    (new Thread(r0)).start();
    (new Thread(r1)).start();
    (new Thread(r2)).start();
    (new Thread(r3)).start();
    (new Thread(r4)).start();
    (new Thread(r5)).start();
    (new Thread(r6)).start();
    (new Thread(r7)).start();
    (new Thread(r8)).start();
    (new Thread(r9)).start();

    (new Thread(w0)).start();
    (new Thread(w1)).start();
    (new Thread(w2)).start();
    (new Thread(w3)).start();
    (new Thread(w4)).start();
    (new Thread(w5)).start();
    (new Thread(w6)).start();
    (new Thread(w7)).start();
    (new Thread(w8)).start();
    (new Thread(w9)).start();
  }

}

class ReadingRoom {

  private int numberOfReaders = 0;

  public ReadingRoom() {
  }

  public synchronized void startReading() {
    while (numberOfReaders < 0) {
      try {
        wait();
      } catch (InterruptedException e) {}
    }
    ++numberOfReaders;
  }

  public synchronized void stopReading() {
    --numberOfReaders;
    if (numberOfReaders == 0) {
      notify();
    }
  }

  public synchronized void startWriting() {
    while (numberOfReaders != 0) {
      try {
        wait();
      } catch (InterruptedException e) {}
    }
    numberOfReaders = -1;
  }

  public synchronized void stopWriting() {
    numberOfReaders = 0;
    notify();
  }

}

class Reader implements Runnable {
  private int nr;
  private ReadingRoom readingRoom;

  public Reader(int nr, ReadingRoom readingRoom) {
    this.nr = nr;
    this.readingRoom = readingRoom;
  }

  public void run() {
    while (true) {
      readingRoom.startReading();
      System.out.println("Czytelnik nr " + nr + " czyta");
      readingRoom.stopReading();
    }
  }
}

class Writer implements Runnable {
  private int nr;
  private ReadingRoom readingRoom;
  private boolean writing = false;

  public Writer(int nr, ReadingRoom readingRoom) {
    this.nr = nr;
    this.readingRoom = readingRoom;
  }

  public void run() {
    while (true) {
      /* @(.inline infinite, .annotation @@NOTIFY_THREAD)observable */
      readingRoom.startWriting();
      /* @observable */
      writing = true;
      readingRoom.stopWriting();
      writing = false;
    }
  }
}

