public class RaceCondition4
{
  public static void main(String[] args) {
    Variable variable = new Variable();
    Thread b1 = new Thread(new Beaver(variable, 4));
    Thread b2 = new Thread(new Beaver(variable, 4));
    b1.start();
    b2.start();
    (new Thread(new Observer(b1, b2, variable, 8))).start();
  }
}

class Variable {

  private int value;

  Variable() {
    this.value = 0;
  }

  public synchronized int getValue() {
    return value;
  }

  public synchronized void setValue(int value) {
    this.value = value;
  }

}

class Observer implements Runnable {
  private Thread b1, b2;
  private Variable variable;
  private int expectedResult;
  private boolean error;

  public Observer(Thread b1, Thread b2, Variable variable, int expectedResult) {
    this.b1 = b1;
    this.b2 = b2;
    this.variable = variable;
    this.expectedResult = expectedResult;
    this.error = false;
  }

  public void run() {
    try {
      b1.join();
    } catch (Exception e) {}
    try {
      b2.join();
    } catch (Exception e) {}
    if (variable.getValue() != expectedResult) {
      /* @observable */
      error = true;
    }
  }
}

class Beaver implements Runnable {
  private Variable variable;
  private int limit;

  public Beaver(Variable variable, int limit) {
    this.variable = variable;
    this.limit = limit;
  }

  public void run() {
    for (int j = 0; j < limit; ++j) {
      int tmp = variable.getValue() + 1;
      variable.setValue(tmp);
    }
  }
}

