#define N 5  /* number of cryptographers max 254 */    

int finished = 0; 		/* how many cryptographers have finished */
byte coin[N] = N; 		/* results of flipping */
bool paid[N] = false;		/* who pays */

bool notPaid = true; 		/* to ensure that at most one pays */
bool even = true;    		/* whether number of differences is even */

active proctype Cryptographer0() {
	int neighbour = 1;

/* Am I paying? */
	atomic {
		if
		:: notPaid == true --> 
			notPaid = false; 
			paid[0] = true
		:: skip
		fi
	};

/* Coin tossing */
	if 
	    :: skip --> coin[0] = 1
	    :: skip --> coin[0] = 0
	fi;

/* Witing for neighbour ro throw a coin */
	do
	:: coin[1] == N --> skip
	:: else -> break
	od;

/* looking for differencess */
	if
	:: coin[0] == coin[1] -->
		if 
		:: paid[0] == false --> 
			atomic { finished = finished + 1 }
		:: else -->
			atomic { even = !even; 
			finished = finished + 1 }
		fi
	:: else --> 
		if
		:: paid[0] == false -->
			atomic { even = !even;
			finished = finished + 1 }
		:: else -->
			atomic { finished = finished + 1 }
		fi
	fi

}

active proctype Cryptographer1() {
	int neighbour = 2;

/* Am I paying? */
	atomic {
		if
		:: notPaid == true --> 
			notPaid = false; 
			paid[1] = true
		:: skip
		fi
	};

/* Coin tossing */
	if 
	    :: skip --> coin[1] = 1
	    :: skip --> coin[1] = 0
	fi;

/* Witing for neighbour ro throw a coin */
	do
	:: coin[2] == N --> skip
	:: else -> break
	od;

/* looking for differencess */
	if
	:: coin[1] == coin[2] -->
		if 
		:: paid[1] == false --> 
			atomic { finished = finished + 1 }
		:: else -->
			atomic { even = !even; 
			finished = finished + 1 }
		fi
	:: else --> 
		if
		:: paid[1] == false -->
			atomic { even = !even;
			finished = finished + 1 }
		:: else -->
			atomic { finished = finished + 1 }
		fi
	fi

}
 
active proctype Cryptographer2() {
	int neighbour = 3;

/* Am I paying? */
	atomic {
		if
		:: notPaid == true --> 
			notPaid = false; 
			paid[2] = true
		:: skip
		fi
	};

/* Coin tossing */
	if 
	    :: skip --> coin[2] = 1
	    :: skip --> coin[2] = 0
	fi;

/* Witing for neighbour ro throw a coin */
	do
	:: coin[3] == N --> skip
	:: else -> break
	od;

/* looking for differencess */
	if
	:: coin[2] == coin[3] -->
		if 
		:: paid[2] == false --> 
			atomic { finished = finished + 1 }
		:: else -->
			atomic { even = !even; 
			finished = finished + 1 }
		fi
	:: else --> 
		if
		:: paid[2] == false -->
			atomic { even = !even;
			finished = finished + 1 }
		:: else -->
			atomic { finished = finished + 1 }
		fi
	fi

}

active proctype Cryptographer3() {
	int neighbour = 4;

/* Am I paying? */
	atomic {
		if
		:: notPaid == true --> 
			notPaid = false; 
			paid[3] = true
		:: skip
		fi
	};

/* Coin tossing */
	if 
	    :: skip --> coin[3] = 1
	    :: skip --> coin[3] = 0
	fi;

/* Witing for neighbour ro throw a coin */
	do
	:: coin[4] == N --> skip
	:: else -> break
	od;

/* looking for differencess */
	if
	:: coin[3] == coin[4] -->
		if 
		:: paid[3] == false --> 
			atomic { finished = finished + 1 }
		:: else -->
			atomic { even = !even; 
			finished = finished + 1 }
		fi
	:: else --> 
		if
		:: paid[3] == false -->
			atomic { even = !even;
			finished = finished + 1 }
		:: else -->
			atomic { finished = finished + 1 }
		fi
	fi

}

active proctype Cryptographer4() {
	int neighbour = 0;

/* Am I paying? */
	atomic {
		if
		:: notPaid == true --> 
			notPaid = false; 
			paid[4] = true
		:: skip
		fi
	};

/* Coin tossing */
	if 
	    :: skip --> coin[4] = 1
	    :: skip --> coin[4] = 0
	fi;

/* Witing for neighbour ro throw a coin */
	do
	:: coin[0] == N --> skip
	:: else -> break
	od;

/* looking for differencess */
	if
	:: coin[4] == coin[0] -->
		if 
		:: paid[4] == false --> 
			atomic { finished = finished + 1 }
		:: else -->
			atomic { even = !even; 
			finished = finished + 1 }
		fi
	:: else --> 
		if
		:: paid[4] == false -->
			atomic { even = !even;
			finished = finished + 1 }
		:: else -->
			atomic { finished = finished + 1 }
		fi
	fi

}

never {
T0:
	do
	:: (finished==N) & even & !(!paid[0] & !paid[1] & !paid[2] & !paid[3] & !paid[4]) --> goto T1
	:: (finished==N) & !even & !(paid[0] || paid[1] || paid[2] || paid[3] || paid[4]) --> goto T1
	:: skip
	od;
T1:
	skip
}
